<'
package csco_addrmap;

define RegisterMap csco_addrmap_env_u ;

extend csco_addrmap_env_u {
   !regmap_region : csco_addrmap_physical_region_s ;
   !regmap_scope : csco_addrmap_name_scope_s ;
   !regmap_region_history : list (key:name) of csco_addrmap_physical_region_s ;
   !entry : csco_addrmap_reg_entry_s ;
   populate_from_regmap(top_scope: string) : csco_addrmap_name_scope_s is {
      regmap_scope = new csco_addrmap_name_scope_s;
      regmap_region_history.clear() ;
      createRegMap();
      if regmap_region.entries.is_empty() == FALSE {
        regmap_scope.add_child_region(regmap_region);
      };
      result = regmap_scope ;
   };

   createRegMap() is undefined;

   AddRegisterFile(regName:string, address:uint(bits:64), widthInBits:uint,
                         numUnits:uint, addrIncrement:uint, is_err:bool) is {
             // filter and adjust regName on top_scope
             // add a new csco_addrmap_mem_entry_s instance to name_scope
   };

   AddRegister(regName:string, address:uint(bits:64), widthInBits:uint, is_err:bool) is {
             // filter and adjust regName on top_scope
             // add a new csco_addrmap_reg_entry_s instance to name_scope
     var regName_split : list of string = str_split(regName,".");
     assert regmap_region.width == (widthInBits+7)/8 ;
     entry = new ;
     entry.name = regName ;
     entry.offset = address ;
     if regName_split.size() > 1 { 
       var new_name :=  str_join(regName_split[..regName_split.size()-2],".");
       var new_region : csco_addrmap_physical_region_s ;
       if regmap_region_history.key_exists(new_name) {
         new_region = regmap_region_history.key(new_name) ;
       } else {
         new_region = new ;
         new_region.name = new_name ;
         new_region.width = regmap_region.width ;
         regmap_scope.add_child_region(new_region) ;
         regmap_region_history.add(new_region) ;
       };
       new_region.add_entry(entry) ;
     } else {
       regmap_region.add_entry(entry) ;
     };
   };

   AddField(regName:string, fieldName:string, sizeInBits:uint, offset:uint,
            permissions:csco_addrmap_sw_access_t, initiallyX:bool, initialValue:uint(bits:64)) is {
             // filter and adjust regName on top_scope
             // lookup regName, which will already exist in name_scope
             // add a new csco_addrmap_field_s instance to the reg/mem
        assert regName == entry.name ;
        var field : csco_addrmap_narrow_field_s = new ;
        field.name = fieldName ;
        field.width = sizeInBits ;
        field.lsb_pos = offset ;
        field.sw_access = permissions ;
        field.side_effects = 0 ;
        entry.fields.add(field) ;
   };
};
'>
