//-----------------------------------------------------------------------------
//
//   Filename : csco_arithm_gcd.e
//   Language : 'e'
//   Author   : Joseph H. Zhang
//
//   General Description: Uses Euclidean algorithm to calculate absolute 
//                        value of greatest common divisor of 2 integers.
//
//   History:
//   03/17/07  JHZ  Initial version 
//
//-----------------------------------------------------------------------------

<'
package csco_arithm;

extend csco_arithm_utils_u {
  gcd(a : int(bits:*), b : int(bits:*)) : int(bits:*) is {
    var rem : int(bits:*);
    var big : int(bits:*);
    var small : int(bits:*);

    if abs(a) > abs(b) {
      big = abs(a);
      small = abs(b);
    }
    else {
      big = abs(b);
      small = abs(a);
    };

    rem = big % small;
    while rem != 0 {
      big = small;
      small = rem;
      rem = big % small;
    };

    result = small;
  };
};


'>
