//-----------------------------------------------------------------------------
//
//   Filename : csco_arithm_lcm.e
//   Language : 'e'
//   Author   : Joseph H. Zhang
//
//   General Description: Uses GCD algorithm to find absolute value of least
//                        common multiple of 2 integers.
//
//   History:
//   03/17/07  JHZ  Initial version 
//
//-----------------------------------------------------------------------------
<'
package csco_arithm;

import csco_arithm_gcd;


extend csco_arithm_utils_u {
  lcm(a : int(bits:*), b : int(bits:*)) : int(bits:*) is {
    var abs_a : int(bits:*) = abs(a);
    var abs_b : int(bits:*) = abs(b);

    result = (abs_a * abs_b) / (sys.csco_arithm.gcd(a, b));
  };
};


'>
