// ----------------------------------------------------------------------------
// File name    : csco_base_env_top.e
//              :
// Project      : csco_base_env
//              :
// Created On   : 11/11/2005
//              :
//              :
// Description  : Imports all files necessary to construct a csco_base_env testbench
//              :
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Copyright 2005-2006 (c) Cisco Systems Inc.
// ----------------------------------------------------------------------------
<'
package csco_base_env;

define CSCO_BASE_ENV_VERSION_2_0;
define CSCO_BASE_ENV_VERSION_2_0_OR_LATER;
define CSCO_BASE_ENV_VERSION_1_0_OR_LATER;

// Specman patches required for base_env files
import vr_patches_loadable/e/vr_patches_loadable_top;


// utility packages used by various core packages.
import csco_reflection_extensions_top.e;
import csco_sequence_extensions/e/csco_sequence_extensions_top;

// set Specman configuration defaults (set_config())
import csco_base_env_config_specman;

// core component packages of the base environment.
import csco_verbosity/e/csco_verbosity_top;     // messaging verbosity control
import csco_clkgen/e/csco_clkgen_top;           // clock generator
import csco_testflow/e/csco_testflow_top;       // global test flow control
import csco_config/e/csco_config_top;           // configuartion
import csco_trans/e/csco_trans_top;             // transaction linking/history
import csco_rate_stats/e/csco_rate_stats_top;   // rate stats collection
import csco_addrmap/e/csco_addrmap_top;         // reg/mem access
import csco_event_phy/e/csco_event_phy_top;     // interrupt monitoring
import csco_event/e/csco_event_top;             // event handling
import csco_tb/e/csco_tb_top;                   // root testbench
import csco_ovl_specman/e/csco_ovl_specman_top; // OVL integration

// extensions for component integration
import csco_base_env_types;
import csco_base_env_addrmap;
import csco_base_env_config;
import csco_base_env_testflow;
import csco_base_env_event;
import csco_base_env_rate_stats;
import csco_base_env_dut_reset;

'>
