//-----------------------------------------------------------------------------
// filename: test_max_size.e
//
// description:
//   allocate an entire memory of the specified size to measure
//   fully utilized memory allocation of each implementation
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// Copyright 2002-2005 (c) Cisco Systems Inc.
//----------------------------------------------------------------------------
// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you may not use this file except in
// compliance with the License. You may obtain a copy of the License
// at http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is "Cisco generic block-based memory model".
// Portions created by the Initial Developer are Copyright (C) 2002-2005
// Cisco Systems Inc. All Rights Reserved.
//----------------------------------------------------------------------------
<'
define CSCO_BLK_MEMORY_DEBUG_ASSERTIONS;
import csco_blk_memory/tests/testbench;

extend sys {
  // execute a single write to fill entire cfgd memory
  keep count == 1;
  keep transaction.operation == WRITE;
  keep transaction.addr == 0;
  keep transaction.size_range == max_test_size;
  keep transaction.size == max_test_size.as_a(csco_blk_memory_addr_t);

  run() is also {
    // and dump the specman memory stats
// FIXME causes test to loop endlessly (specman bug??)
//    specman("show mem");
  };
};

'>
