//==============================================================================
//
//   Filename : csco_clkgen_fullchip_dut.v
//   Author   : Sean Smith
//   username : sesmith
//
//   General Description: Sample dut to illustrate clock usage
//
// ------------------------------------------------------------------------
// >>>>>>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<<<
// ------------------------------------------------------------------------
// Copyright 2003 (c) Cisco Systems Inc.
// Cisco Confidential
//
// ------------------------------------------------------------------------
//
//
//   History:
//     01/25/012 SWS    Initial template
//==============================================================================

`timescale 1ns/1ns

module csco_clkgen_fullchip_dut ( clk1,clk2 );

  input clk1;
  input clk2;

  integer count1;
  integer count2;

  initial count1 = 0;
  initial count2 = 0;

  always @(posedge clk1) begin
    count1 = count1 + 1;
    if ((count1 % 100) == 0) begin
      $display("%t ns (%m) NOTE: DUT saw rising edge of clock #1. waiting 100 cycles",$time);
    end
  end

  always @(posedge clk2) begin
    count2 = count2 + 1;
    if ((count2 % 100) == 0) begin
      $display("%t ns (%m) NOTE: DUT saw rising edge of clock #2. waiting 100 cycles",$time);
    end
  end

endmodule
