//==============================================================================
//
//   Filename : csco_clkgen_dut_1.v
//   Author   : Sean Smith
//   username : sesmith
//
//   General Description: Sample dut to illustrate clock usage
//
// ------------------------------------------------------------------------
// >>>>>>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<<<
// ------------------------------------------------------------------------
// Copyright 2003 (c) Cisco Systems Inc.
// Cisco Confidential
//
// ------------------------------------------------------------------------
//
//
//   History:
//     01/25/012 SWS    Initial template
//==============================================================================

`timescale 1ns/1ns

module csco_clkgen_dut_1 ( clk );

  input clk;

  integer count;

  initial count = 0;

  always @(posedge clk) begin
    count = count + 1;
    if ((count % 100) == 0) begin
      $display("%t ns (%m) NOTE: DUT saw rising edge of clock. waiting 100 cycles",$time);
    end
  end

endmodule
