//-------------------------------------------------------------------------------------------------------------
//
//   Filename : csco_clkgen_unit_dev_testbench_sys.e
//   Language : 'e'
//   Author   : Sean Smith (Cisco)
//
//   General Description: Example Unit level Testbench to illustrate the usage of the csco_clkgen model
//                        in several scenarios.  This model illustrates how to instantiate the model,
//                        configure its output and connect it to your system.
//
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// Copyright 2003 (c) Cisco Systems Inc.
//
// ------------------------------------------------------------------------
//
//
//   History:
//   01/07/02  SWS  Initial Coding
//
//--------------------------------------------------------------------------------------------------------------

<'
import csco_clkgen_unit_dev/csco_clkgen_unit_dev_testbench_top.e;  // Import the Whole eNV

//========================================================================
// TOP LEVEL TEST STUFF
//========================================================================

//
// SWS: Remove this for PMC Version. its cisco specific.
//

extend sys {                                               // Extend Sys and instance the unit level tb and set its
  unit_tb : csco_clkgen_unit_tb_env is instance;           // hdl path
};                                                         // End Extend Sys

extend core_clk_gen csco_clkgen_config_s {                 // Apply the clock mode here where we instance
                                                           // That way if at another level like fullchip level
                                                           // we want to constrain differently then we can
  keep config_mode == DEFAULT;
};                                                         // End Extend

extend cpu_clk_gen csco_clkgen_config_s {
  keep config_mode.reset_soft();                           // remove soft constraint to use DEFAULT MODE!
  keep config_mode in [DEFAULT,NO_JITTER];
};                                                         // End Extend

'>
