// ------------------------------------------------------------------------
// file: csco_clkgen_sample_evc_3.e
//
// author: Sean Smith
//
// description: Sample eVC unit that hooks to clocks via HDL Signals
//
// history:
// 01/31/03 : sesmith : Initial Version
//
// ------------------------------------------------------------------------

<'

unit csco_clkgen_sample_evc_3 like any_env {

  clk_sig : string;                                        // User Must constrain clock signal to HDL clock for model to function
                                                           // NOTE: This signal should really be in a config block

  event clk_rise is rise ('(clk_sig)') @sim;               // Here's where the model creates its event the TCM uses.
                                                           // Even if the model is a method1 model doesn't mean we
                                                           // can't loate its event statement and overload it.

  some_tcm() @clk_rise is {                                // Simple TCM to illustrate the clock is working correctly
    while (TRUE) {
      messagef(MEDIUM,"NOTE: Saw clock event, waiting 100 clocks\n");
      wait [100];
    };                                                     // End while
  };

  short_name() : string is also {                          // Change the message format
      result = appendf("SAMPLE_EVC_3");
  };

  run() is also {                                          // Start our sample tcm
    start some_tcm();
  };

};

'>
