// ------------------------------------------------------------------------
// file: csco_clkgen_sample_evc_4.e
//
// author: Sean Smith
//
// description: Sample eVC unit that hooks to clocks via Specman Event
//
// history:
// 01/31/03 : sesmith : Initial Version
//
// ------------------------------------------------------------------------

<'

unit csco_clkgen_sample_evc_4 like any_env {

  event clk_rise;                                          // Empty event for model user to overload

  some_tcm() @clk_rise is {                                // Some TCM to show clock is hooked up and working
    while (TRUE) {
      messagef(MEDIUM,"NOTE: Saw clock event, waiting 100 clocks\n");
      wait [100];
    };                                                     // End while
  };

  short_name() : string is also {                          // Change the message format
      result = appendf("SAMPLE_EVC_4");
  };

  run() is also {
    start some_tcm();                                      // Start the TCM
  };

};

'>
