// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
//
// File name    : csco_clkgen_unit_dev2_testbench_coverage.e
//              :
// Title        : Example coverage file for csco_clkgen modules used in unit
//                level tetbench example #2.
//
// Project      : na
//              :
// Created On   : 02/04/2003
//              :
//              :
// Purpose      : Define the specific coverage items for the two instances of
//              : the clock generator used in this module.
//              :
// Description  : Example of coverage on csco_clkgen config structs
//              :
//              :
// Assumptions  : none
//              :
// Limitations  : none
//              :
// Known Errors : none
//              :
// Notes        :
//
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Copyright 2003 (c) Cisco Systems Inc.
//
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

<'

// Add Coverage for both our clock gen blocks


extend pci_clk_gen'name csco_clkgen_config_s {
  //
  // Since everything is random on this clock we define a fair#
  // of coverage metrics
  //
  cover csco_clkgen_config_generated(name==pci_clk_gen) using also text = "pci_clk_gen coverage group" is also {

    item inst_name;
    item config_mode using ignore = (config_mode not in [DEFAULT]);// Ignore any modes not for this clock gen

    cross config_mode, inst_name;                          // Now cross mode with instance
  };
};

'>
