This test sets up a unit tree structure with a static config tree and then 
regenerates various portions of the tree to verify the regeneration mechanism.

<'
import csco_config/e/csco_config_top;

type unit_b_color_t : [RED, BLUE, X, Y, Z];
type unit_e_shade_t : [DARK, LIGHT];
type unit_a_temperature_t : [HOT, COLD];
type unit_f_size_t : [BIG, SMALL];
type unit_g_size_t : [BIG, SMALL];


-- This unit doesn't have its own config struct type, but rather uses the config
-- instance of its parent unit (unit_a).
unit unit_f {};

-- This unit doesn't have its own config struct type, but rather uses the config
-- instance of its parent unit (unit_a).
unit unit_g {};

unit unit_a {};
DEFINE_CFG_STRUCT begin
  config_prefix =unit_a,
  parent_unit_type =  unit_a
end;
extend unit_a_config_s {
    temperature : unit_a_temperature_t;

    cfg_field_a1 : uint;
    cfg_field_a2 : uint;
};
extend unit_a {
    !temperature : unit_a_temperature_t;
    csco_config_update_subtypes() is also { temperature = config.temperature };
--      keep temperature == value(config.temperature);
  check() is also { check temperature == config.temperature };
};
extend HOT unit_a {
    -- This declaration implies that the unit_f_size config field in unit_a_config_s
    -- must be BIG.
    uf : BIG unit_f is instance;
--    keep hot_config.unit_f_size == BIG ;

    -- This declaration implies that the unit_g_size config field in unit_a_config_s
    -- must be SMALL.
    ug : SMALL unit_g is instance;
--    keep hot_config.unit_g_size == SMALL ;
};
extend HOT unit_a_config_s {
    unit_f_size : unit_f_size_t;
      keep unit_f_size == BIG ;
    unit_g_size : unit_g_size_t;
      keep unit_g_size == SMALL ;
};




extend unit_f {
  USE_PARENT_CFG begin
    parent_config_type = HOT unit_a_config_s,
    parent_unit_type = HOT unit_a
  end ;
    !size : unit_f_size_t;
    csco_config_update_subtypes() is also { size = config.unit_f_size };
--      keep size == value(config.unit_f_size);
  check() is also { check size == config.unit_f_size else dut_error("size ",size," config size ",config.unit_f_size) };
};

extend unit_g {
  USE_PARENT_CFG begin 
    parent_config_type = HOT unit_a_config_s,
    parent_unit_type = HOT unit_a
  end;
    !size : unit_g_size_t;
    csco_config_update_subtypes() is also { size = config.unit_g_size };
--      keep size == value(config.unit_g_size);
  check() is also { check size == config.unit_g_size };
};



unit unit_c {
    ua : HOT unit_a is instance;
};
DEFINE_CFG_STRUCT begin
  config_prefix  = unit_c ,
  parent_unit_type=unit_c
end;
extend unit_c_config_s {
    cfg_field_c1 : uint;
    cfg_field_c2 : uint;
};
-- Note that unit_a_config_s must be of the stated sub-type due to previous sub-type instantiations of
-- unit_f and unit_g.
--ADD_CHILD_CFG (unit_c) ua (unit_c_config_s) cfg_a (BIG'unit_f_size SMALL'unit_g_size HOT unit_a_config_s);
INSTANCE_CFG begin
  config_instance_name = cfg_a,
  child_config_type = HOT unit_a_config_s,
  parent_config_type = unit_c_config_s,
  parent_unit_type = unit_c,
  child_unit_type = HOT unit_a
end;

unit unit_b {};
DEFINE_CFG_STRUCT begin
  config_prefix=unit_b,  
  parent_unit_type  =   unit_b
end;

extend unit_b {
    !color : unit_b_color_t;
    csco_config_update_subtypes() is also { color = config.color };
--      keep color == value(config.color);
  check() is also { check color == config.color };

    !b3 : uint;
--      keep b3 == value(config.cfg_field_b3);
    csco_config_update_subtypes() is also {
       b3 = config.cfg_field_b3 ;
    };
  check() is also { check b3 == config.cfg_field_b3 };

};
extend unit_b_config_s {
    color : unit_b_color_t;

    cfg_field_b1 : uint;
    cfg_field_b2 : uint;
    cfg_field_b3 : uint;

    when BLUE unit_b_config_s {
--        num_of_c_units : uint;
--          keep c_configs.size() == num_of_c_units;

        blue_cfg_field_b1 : uint;
        blue_cfg_field_b2 : uint;
    };
};
extend BLUE unit_b {
    COPY_CFG_AS_SUBTYPE begin
      orig_instance_name= config, 
      copy_instance_name =  blue_cfg , 
      copy_type = BLUE unit_b_config_s
    end;

    c_units : list of unit_c is instance;
      keep c_units.size() == value(blue_cfg.c_configs.size());
--      keep c_units.size() == 3 ; -- error -- too many
--      keep c_units.size() == 1 ; -- error -- too few
};

--  check() is also { check c_units.size() == blue_cfg.c_configs_size };

--ADD_CHILD_CFG (BLUE unit_b) c_units=IS_LIST (BLUE unit_b_config_s) c_configs (unit_c_config_s);
INSTANCE_CFG_LIST begin
  config_instance_name = c_configs,
  child_config_type = unit_c_config_s,
  parent_config_type = BLUE unit_b_config_s,
  parent_unit_type = BLUE unit_b,
  child_unit_type = unit_c
end;

unit unit_e {};
DEFINE_CFG_STRUCT begin
  config_prefix   =  unit_e  ,
  parent_unit_type = unit_e
end;


extend unit_e_config_s {
    shade : unit_e_shade_t;
};
extend unit_e {
    !shade : unit_e_shade_t;
    csco_config_update_subtypes() is also { shade = config.shade };
--      keep shade == value(config.shade);
  check() is also { check shade == config.shade };
};
extend DARK unit_e {
    ua : HOT unit_a is instance;

    -- Note that unit_b is instantiated directly as a BLUE unit_b.
    blue_b : BLUE unit_b is instance;

    COPY_CFG_AS_SUBTYPE begin
      orig_instance_name  =config  , 
      copy_instance_name=  dark_cfg, 
      copy_type = DARK unit_e_config_s
    end;
};
-- Note that unit_a_config_s must be of the stated sub-type due to previous sub-type instantiations of
-- unit_f and unit_g.
--ADD_CHILD_CFG (DARK unit_e) ua (DARK unit_e_config_s) cfg_a (BIG'unit_f_size SMALL'unit_g_size HOT unit_a_config_s);
INSTANCE_CFG begin
  config_instance_name = cfg_a,
  child_config_type = HOT unit_a_config_s,
  parent_config_type = DARK unit_e_config_s,
  parent_unit_type = DARK unit_e,
  child_unit_type = HOT unit_a
end;

-- Note that unit_b_config_s must be of the BLUE sub-type due to the instantiation of BLUE unit_b in 
-- the parent unit_e.
--ADD_CHILD_CFG (DARK unit_e) blue_b (DARK unit_e_config_s) cfg_b (BLUE unit_b_config_s);
INSTANCE_CFG begin
  config_instance_name = cfg_b,
  child_config_type = BLUE unit_b_config_s,
  parent_config_type = DARK unit_e_config_s,
  parent_unit_type = DARK unit_e,
  child_unit_type = BLUE unit_b
end;



-------------------------------------------------------------------
-- Integration logic
-------------------------------------------------------------------
extend sys {
    dark_e : DARK unit_e is instance;
      -- This constraint is necssary to avoid contradictions when generating 
      -- the 'shade' field inside unit_e_config_s. Since dark_e is the unit
      -- holding the root of the config tree, we can't use ADD_CHILD_CFG to
      -- explicitly instantiate its config struct as a DARK subtype.
      keep dark_e.config.shade == DARK;
};

extend DARK unit_e_config_s {
    keep cfg_a.cfg_field_a1 == cfg_b.cfg_field_b1 + 10;
  check() is also { check cfg_a.cfg_field_a1 == cfg_b.cfg_field_b1 + 10 };
    keep cfg_a.cfg_field_a2 == cfg_b.c_configs[0].cfg_field_c2 + 5;
  check() is also { check cfg_a.cfg_field_a2 == cfg_b.c_configs[0].cfg_field_c2 + 5 };
};

extend BLUE unit_b_config_s {
    keep c_configs.size() == 2;
    keep c_configs[0].cfg_a.cfg_field_a1 == c_configs[1].cfg_a.cfg_field_a1 + 30;
};

extend sys {
    print_relevant_fields() is {
        messagef(NONE, "dark_e.dark_cfg.shade = %s\n", dark_e.dark_cfg.shade);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.cfg_field_b2 = %u\n", dark_e.dark_cfg.cfg_b.cfg_field_b2);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.c_configs[0].cfg_a.cfg_field_a2 = %u\n", dark_e.dark_cfg.cfg_b.c_configs[0].cfg_a.cfg_field_a2);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.c_configs[1].cfg_a.cfg_field_a2 = %u\n", dark_e.dark_cfg.cfg_b.c_configs[1].cfg_a.cfg_field_a2);
        messagef(NONE, "dark_e.dark_cfg.cfg_a.cfg_field_a1 = %u\n", dark_e.dark_cfg.cfg_a.cfg_field_a1);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.cfg_field_b1 = %u\n", dark_e.dark_cfg.cfg_b.cfg_field_b1);
        messagef(NONE, "dark_e.dark_cfg.cfg_a.cfg_field_a2 = %u\n", dark_e.dark_cfg.cfg_a.cfg_field_a2);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.c_configs[0].cfg_field_c2 = %u\n", dark_e.dark_cfg.cfg_b.c_configs[0].cfg_field_c2);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.c_configs[0].cfg_a.cfg_field_a1 = %u\n", dark_e.dark_cfg.cfg_b.c_configs[0].cfg_a.cfg_field_a1);
        messagef(NONE, "dark_e.dark_cfg.cfg_b.c_configs[1].cfg_a.cfg_field_a1 = %u\n", dark_e.dark_cfg.cfg_b.c_configs[1].cfg_a.cfg_field_a1);
        outf("\n");
    };

    run() is also {
        print_relevant_fields();
        start regen_test();
    };

    regen_test() @sys.any is {
        wait [50] * cycle;
        REGEN_CFG_BRANCH sys.dark_e.dark_cfg.cfg_b;
//        REGEN_CFG_BRANCH sys.dark_e.blue_b.config;
        print_relevant_fields();

//        wait [50] * cycle;
//        REGEN_CFG_BRANCH sys.dark_e.config;
//        print_relevant_fields();

        -- To be able regenerate the following node, the config structs for the unit_c's must be individually
        -- instantiated as opposed to as a list because the Specman generator doesn't allow complex expressions
        -- in a 'gen' statement.
        --wait [50] * cycle;
        --REGEN_CFG_BRANCH sys.dark_e.dark_cfg.cfg_b.c_configs[0];
        --print_relevant_fields();

        stop_run();
    };
};


'>
sys
   DARK unit_e
      HOT unit_a
          BIG unit_f
          SMALL unit_g
      BLUE unit_b
          list of unit_c
              HOT unit_a
                  BIG unit_f
                  SMALL unit_g
