//------------------------------------------------------------------------
// Title        : csco_event package Env.
// Project      : csco_event
//              :
// Created On   : 01/10/2006
//              :
//              :
// Description  : 
//              :
//------------------------------------------------------------------------
//------------------------------------------------------------------------
// Copyright 2006 (c) Cisco Systems Inc.
//------------------------------------------------------------------------
<' 
package csco_event;

//Event environment container
unit csco_event_env_u like any_env {

  //Event Tree data structure that is built up from an XML representation
  //of the event hierarchy in the DUT. A default populate method is provided
  //in ./populate/csco_event_populate_xml.e
  event_tree : csco_event_s;

  post_generate() is first {
    event_tree.types = config.names;
    if !config.names.is_empty() {
      event_tree.first_idx = config.names.min(it.as_a(uint)).as_a(uint);
    };
  };
};

DEFINE_CFG_STRUCT begin
  config_prefix = csco_event,
  parent_unit_type = csco_event_env_u
end;

//Config structure for the eVC
extend csco_event_config_s {
  // event types handled by this instance
  names : list of csco_event_name_t;
    keep soft names.size() == 0;

  // Flag to enable automatic event test sequences
  auto_test : bool;
    keep soft !auto_test;

  // Config field that determines whether DUT uses enables or masks
  use_mask : bool;
    keep soft !use_mask;
};

'>
