`timescale 1ns/100ps

`define ASSERT_ON
`define ASSERT_INIT_MSG
`include "ovl_header.h"

module test();
 
  reg clk;
  initial clk = 0;
  always #(0.5) clk = ~clk;

  reg reset_n;
  initial begin
    reset_n = 1'b0;
    #2.5 reset_n = 1'b1;
  end

  reg [7:0] count;
  always @(posedge clk)
    if(!reset_n)
      count <= 0;
    else
      count <= count + 1;

  assert_always #(`OVL_NON_FATAL_ERROR, 0, "error every cycle")
    error_every_cycle(clk, reset_n, 1'b0);

  assert_always #(`OVL_NON_FATAL_ERROR, 0, "error alternate cycles")
    error_alternate_cycles(clk, reset_n, !count[0]);

  assert_always #(`OVL_NOTE_ALL, 0, "note every cycle")
    note_every_cycle(clk, reset_n, 1'b0);

  assert_always #(`OVL_NOTE_ALL, 0, "note alternate cycles")
    note_alternate_cycles(clk, reset_n, !count[0]);

  assert_always #(`OVL_NOTE_FIRST_N + 4, 0, "note first 4 cycles")
    note4_every_cycle(clk, reset_n, 1'b0);

  assert_always #(`OVL_NOTE_FIRST_N + 4, 0, "note first 4 alternate cycles")
    note4_alternate_cycles(clk, reset_n, !count[0]);

endmodule
