<'
import csco_erm_ext/e/csco_erm_ext_top;
import csco_base_env/e/csco_base_env_top;


extend csco_trans_kind_t : [ATM];

struct atm_trans_s like csco_trans_s {
  keep tracking.trans_kind == ATM;

  run() is also {
    tracking.trans_kind = ATM;
    tracking.incr_exp_child_cnt(1);
    rate_stats.data_size = 53;
    rate_stats.data_unit = "bytes";
  };
};


extend csco_trans_kind_t : [IP];

struct ip_trans_s like csco_trans_s {
  keep tracking.trans_kind == IP;

  run() is also {
    tracking.trans_kind = IP;
    rate_stats.data_unit = "bytes";
  };
};


extend csco_trans_kind_t : [GENERIC_INPUT];

struct generic_input_trans_s like csco_trans_s {
  keep tracking.trans_kind == GENERIC_INPUT;

  run() is also {
    tracking.trans_kind = GENERIC_INPUT;
    tracking.incr_exp_child_cnt(1);
  };
};


extend csco_trans_kind_t : [GENERIC_OUTPUT];

struct generic_output_trans_s like csco_trans_s {
  keep tracking.trans_kind == GENERIC_OUTPUT;

  run() is also {
    tracking.trans_kind = GENERIC_OUTPUT;
  };
};



extend csco_tb_name_t : [CSCO_RATE_STATS];

extend sys {
  keep soft top_tb.config.tb_name == CSCO_RATE_STATS;
}; // extend sys

extend message_logger {
  keep format == RTP_LONG;
  keep verbosity == HIGH;
  keep tags == {NORMAL; CSCO_RATE_STATS};
};

extend csco_rate_stats_stream_name_t : [ATM_IP, AGGREGATE, GENERIC_TRANS];
type csco_rate_stats_atm_ip_inst_t : [INST_0, INST_1];

extend ATM_IP csco_rate_stats_stream_u {
  inst : csco_rate_stats_atm_ip_inst_t;
  keep for each (p) in params {
    p is a ATM_IP csco_rate_stats_param_s (ap) => ap.inst == inst;
  };
};

extend ATM_IP csco_rate_stats_param_s {
  inst : csco_rate_stats_atm_ip_inst_t;
};

extend INST_0 ATM_IP csco_rate_stats_stream_u {
  keep params.size() == 3;
  keep params[0].name == INPUT_DATA_RATE;
  keep params[1].name == OUTPUT_DATA_RATE;
  keep params[2].name == DATA_THROUGHPUT;
};

extend INST_0 ATM_IP INPUT_DATA_RATE csco_rate_stats_param_s {
  keep min_val == 100_000_000;
};

extend INST_0 ATM_IP OUTPUT_DATA_RATE csco_rate_stats_param_s {
  keep min_val == 100_000_000;
};

extend INST_0 ATM_IP DATA_THROUGHPUT csco_rate_stats_param_s {
  keep min_val == 90;
};

extend INST_1 ATM_IP csco_rate_stats_stream_u {
  keep use_all_params == TRUE;
  keep enable.reset_soft();
};

extend INST_1 ATM_IP INPUT_DATA_RATE csco_rate_stats_param_s {
  keep min_val == 100_000_000;
};

extend INST_1 ATM_IP OUTPUT_DATA_RATE csco_rate_stats_param_s {
  keep min_val == 100_000_000;
};

extend INST_1 ATM_IP DATA_THROUGHPUT csco_rate_stats_param_s {
  keep min_val == 80;
};

extend INST_1 ATM_IP INPUT_TRANS_RATE csco_rate_stats_param_s {
  keep min_val == 1_000_000;
};

extend INST_1 ATM_IP OUTPUT_TRANS_RATE csco_rate_stats_param_s {
  keep min_val == 1_000_000;
};

extend INST_1 ATM_IP TRANS_THROUGHPUT csco_rate_stats_param_s {
  keep min_val == 90;
};

extend INST_1 ATM_IP MIN_LATENCY csco_rate_stats_param_s {
  keep max_val == 1 us;
};

extend INST_1 ATM_IP MAX_LATENCY csco_rate_stats_param_s {
  keep max_val == 1 us;
};

extend INST_1 ATM_IP AVG_LATENCY csco_rate_stats_param_s {
  keep max_val == 1 us;
};

extend AGGREGATE csco_rate_stats_stream_u {
  keep params.size() == 3;
  keep params[0].name == INPUT_TRANS_RATE;
  keep params[1].name == OUTPUT_TRANS_RATE;
  keep params[2].name == TRANS_THROUGHPUT;
};

extend AGGREGATE INPUT_TRANS_RATE csco_rate_stats_param_s {
  keep min_val == 3_000_000;
};

extend AGGREGATE OUTPUT_TRANS_RATE csco_rate_stats_param_s {
  keep min_val == 3_000_000;
};

extend AGGREGATE TRANS_THROUGHPUT csco_rate_stats_param_s {
  keep min_val == 100;
};

extend GENERIC_TRANS INPUT_TRANS_RATE csco_rate_stats_param_s {
  keep min_val == 5_000_000;
};

extend GENERIC_TRANS OUTPUT_TRANS_RATE csco_rate_stats_param_s {
  keep min_val == 5_000_000;
};

extend GENERIC_TRANS TRANS_THROUGHPUT csco_rate_stats_param_s {
  keep min_val == 90;
};

extend GENERIC_TRANS MIN_LATENCY csco_rate_stats_param_s {
  keep max_val == 1 us;
};

extend GENERIC_TRANS MAX_LATENCY csco_rate_stats_param_s {
  keep max_val == 1 us;
};

extend GENERIC_TRANS AVG_LATENCY csco_rate_stats_param_s {
  keep max_val == 1 us;
};

extend GENERIC_TRANS csco_rate_stats_stream_u {
  keep params.size() == 6;
  keep params[0].name == INPUT_TRANS_RATE;
  keep params[1].name == OUTPUT_TRANS_RATE;
  keep params[2].name == TRANS_THROUGHPUT;
  keep params[3].name == AVG_LATENCY;
  keep params[4].name == MIN_LATENCY;
  keep params[5].name == MAX_LATENCY;
};


extend CSCO_RATE_STATS csco_tb_u {
  clkgen : csco_clkgen_u is instance;
    keep clkgen.config.active_passive == ACTIVE;
    keep clkgen.config.period == 2000;
    keep clkgen.config.auto_instance == TRUE;
    keep clkgen.config.edge_mode == POSEDGE;
    keep clkgen.sig_clock.hdl_path() == "~/testbench.clock";

  atm_mon : atm_mon_u is instance;
    keep atm_mon.ip_mon_ptr == read_only(ip_mon);

  ip_mon : ip_mon_u is instance;
    keep ip_mon.stream_ptrs[0] == read_only(atm_ip_streams[0]);
    keep ip_mon.stream_ptrs[1] == read_only(atm_ip_streams[1]);

  atm_ip_streams[2] : list of PHYSICAL ATM_IP'name csco_rate_stats_stream_u is instance;
    keep for each (s) in atm_ip_streams {
      s.inst == index.as_a(csco_rate_stats_atm_ip_inst_t);
      s.inst_name == appendf("ATM_IP_%d", index);
    };

  merged_stream : MERGED AGGREGATE csco_rate_stats_stream_u is instance;
    keep merged_stream.child_streams == {atm_ip_streams[0]; atm_ip_streams[1]};


  input_mon : input_mon_u is instance;
    keep input_mon.output_mon_ptr == read_only(output_mon);

  output_mon : output_mon_u is instance;

  generic_trans_stream : GENERIC_TRANS PHYSICAL csco_rate_stats_stream_u is instance;


  connect_ports() is also {
    for i from 0 to 1 {
      do_bind(atm_mon.add_rate_stats_trans[i], atm_ip_streams[i].add_input_trans);
      do_bind(ip_mon.add_rate_stats_trans[i], atm_ip_streams[i].add_output_trans);
      do_bind(input_mon.add_rate_stats_trans, generic_trans_stream.add_input_trans);
      do_bind(output_mon.add_rate_stats_trans, generic_trans_stream.add_output_trans);
    };
  };

  do_main_test() @sys.any is {
    wait delay(100000 ns);
  }; // do_main_test() 
}; 

unit atm_mon_u {
  CREATE_TESTFLOW;

  ip_mon_ptr : ip_mon_u;

  add_rate_stats_trans[2] : list of out method_port of csco_trans_forward_mp is instance;

  !dummy_root : atm_trans_s;
    keep dummy_root.tracking.trans_kind == ATM;

  !new_tr : atm_trans_s;

  port_no : bit;

  do_main_test() @sys.any is {
    var inter_trans_delay : uint;

    for i from 0 to 99 {
      gen inter_trans_delay keeping {
        it in [100..100];
      };
      wait delay (inter_trans_delay);        // inter-trans delay.

      gen dummy_root;
      gen port_no;
      new_tr = new;
      wait delay(50 ns);      // xmt delay.
      dummy_root.tracking.link_trans(new_tr);
      add_rate_stats_trans[port_no]$(new_tr);
      start ip_mon_ptr.add_downstream_tr(new_tr, port_no);
    };
  };
};

unit ip_mon_u {
  CREATE_TESTFLOW;

  stream_ptrs[2] : list of ATM_IP PHYSICAL csco_rate_stats_stream_u;

  add_rate_stats_trans[2] : list of out method_port of csco_trans_forward_mp is instance;

  add_downstream_tr(atm_tr : atm_trans_s, port_no : bit) @sys.any is {
    var device_delay : uint;
    var ip_tr : ip_trans_s;


    gen device_delay keeping {
      it in [100..500];
    };
    wait delay (device_delay);                         // device delay

    ip_tr = new;
    gen ip_tr.rate_stats.data_size keeping {
      it >= 32;
      it <= 64;
    };
    wait delay(50 ns);                          // xmt delay
    //add_rate_stats_trans[port_no]$(ip_tr);
    stream_ptrs[port_no].add_output_tr(ip_tr);
    atm_tr.tracking.link_trans(ip_tr);
    ip_tr.tracking.set_leaf();
  };
};


unit input_mon_u {
  CREATE_TESTFLOW;

  output_mon_ptr : output_mon_u;

  add_rate_stats_trans : out method_port of csco_trans_forward_mp is instance;

  !dummy_root : generic_input_trans_s;
    keep dummy_root.tracking.trans_kind == GENERIC_INPUT;

  !new_tr : generic_input_trans_s;

  do_main_test() @sys.any is {
    var inter_trans_delay : uint;

    for i from 0 to 99 {
      gen inter_trans_delay keeping {
        it in [100..100];
      };
      wait delay (inter_trans_delay);        // inter-trans delay.

      gen dummy_root;
      new_tr = new;
      wait delay(50 ns);      // xmt delay.
      dummy_root.tracking.link_trans(new_tr);
      add_rate_stats_trans$(new_tr);
      start output_mon_ptr.add_downstream_tr(new_tr);
    };
  };
};

unit output_mon_u {
  CREATE_TESTFLOW;

  add_rate_stats_trans : out method_port of csco_trans_forward_mp is instance;

  add_downstream_tr(inp_tr : generic_input_trans_s) @sys.any is {
    var device_delay : uint;
    var output_tr : generic_output_trans_s;

    gen device_delay keeping {
      it in [100..500];
    };
    wait delay (device_delay);                         // device delay

    output_tr = new;
    wait delay(50 ns);                          // xmt delay
    add_rate_stats_trans$(output_tr);
    inp_tr.tracking.link_trans(output_tr);
    output_tr.tracking.set_leaf();
  };
};


'>
