<'
import csco_sequence_extensions/e/csco_sequence_extensions_top;

sequence test_seq using
  created_driver = test_seq_driver_u,
  created_kind = test_seq_kind_t;

extend sys {
  keep soft logger.verbosity == MEDIUM;

  driver : test_seq_driver_u is instance;

  on any { emit driver.clock };
};

extend test_seq {
  name : string;
};

//------------------------------------------------------------
extend test_seq_kind_t : [ RANDOM_DELAY ];

extend RANDOM_DELAY test_seq {
  delay : uint;
    keep soft delay in [5..15];

  body() @driver.clock is also {
    message(MEDIUM, "starting ", me, ": ", name, " ", kind, " ", delay);
    wait [delay];
    message(MEDIUM, "ending ", me, ": ", name, " ", kind, " ", delay);
  };
};


//------------------------------------------------------------
extend test_seq_driver_u {
  !independents : list of test_seq;
    keep soft independents.size() in [5..15];
    keep for each in independents {
      soft .kind == RANDOM_DELAY;
      .name == hex("independent[", index, "]");
      .driver == me;
    };

  !dependents : list of test_seq;
    keep soft dependents.size() in [5..15];
    keep for each in dependents {
      soft .kind == RANDOM_DELAY;
      .name == hex("dependent[", index, "]");
      .driver == me;
    };

  !another_dependent : test_seq;
    keep another_dependent.driver == me;
    keep another_dependent.name == "another_dependent";

  run() is also {
    gen (dependents);
    for each in dependents {
      .start_sequence();
    };
    gen (independents);
    for each in independents {
      .start_sequence();
    };
    gen (another_dependent);
    another_dependent.start_sequence();
    for each in dependents {
      .csco_add_dep_list(independents.as_a(list of any_sequence));
    };
    another_dependent.csco_add_dep(independents[4]);
    another_dependent.csco_seq_deps.add(independents[5]);
    dump_state();
  };

  dump_state() is {
    message(MEDIUM, "current state:") {
      //out("    state=", sequence.csco_get_state());
      //out("    seq_count=", csco_get_seq_count());
      out("    independents(", independents.size(), "):");
      for each in independents {
        out("      [", index, "] state=", .csco_get_state());
      };
      out("    dependents(", dependents.size(), "):");
      for each in dependents {
        out("      [", index, "] state=", .csco_get_state());
      };
    };
  };
};

extend MAIN test_seq {
  body() @driver.clock is only {
    driver.raise_objection(TEST_DONE);
    driver.dump_state();
    csco_merge_list(driver.independents.as_a(list of any_sequence));
    message(LOW, kind, " independents merged");
    driver.dump_state();
    csco_merge_list(driver.dependents.as_a(list of any_sequence));
    message(LOW, kind, " dependents merged");
    driver.dump_state();
    csco_merge(driver.another_dependent);
    message(LOW, kind, " all done!");
    driver.dump_state();
    driver.drop_objection(TEST_DONE);
  };
};

'>

//------------------------------------------------------------
extend MAIN test_seq {

  body() @driver.clock is only {
    driver.raise_objection(TEST_DONE);
    dump_state();
    another_dependent.csco_seq_deps.add(independents[0]);
    message(LOW, kind, " forking ", dependents.size(), " dependents");
    csco_fork(dependents.as_a(list of any_sequence));
    sync [0];
    dump_state();
    message(LOW, kind, " doing all ", dependents.size(), " independents");
    csco_do_all(independents.as_a(list of any_sequence));
    dump_state();
    message(LOW, kind, " merging all");
    csco_merge_all();
    dump_state();
    message(LOW, kind, " all done!");
    driver.drop_objection(TEST_DONE);
  };

};

