<'
import csco_testflow/examples/csco_shaggy_top;

extend sys {
  keep logger.verbosity == FULL;
  keep logger.format == RTP_LONG;
  keep logger.tags == {NORMAL; CSCO_TESTFLOW};

  del : time;
    keep del >= 0 ns;
    keep del <= 70 ns;

  run() is also {
    start chip_reset();
  };

  chip_reset() @sys.any is {
    gen del;
    messagef(NONE, "waiting %d ns before doing a chip-wide reset\n", from_specman_scale(del, ns));
    wait delay(del);
    outf("\n");
    messagef(NONE, "doing a chip-wide reset\n");
    csco_shaggy_soc_env_u.reset_unit(PRE_RESET);
    outf("\n");

    gen del keeping {
      it > 12;
    };
    messagef(NONE, "waiting %d ns before doing a chip-wide reset\n", from_specman_scale(del, ns));
    wait delay(del);
    outf("\n");
    messagef(NONE, "doing a chip-wide reset\n");
    csco_shaggy_soc_env_u.reset_unit(RESET);
    outf("\n");
  };
}; // extend sys

extend csco_shaggy_soc_env_u {
  //launch_child_run_phases(stage : csco_testflow_stage_t, obj : csco_testflow_objection_kind_t) @testflow_clk is first {
  //    if stage == MAIN_TEST {
  //        testflow_children[0].run_phase(stage, obj);
  //        messagef(NONE, "wait 2 cycles before launching next child\n");
  //        wait [2] *cycle;

  //        testflow_children[1].run_phase(stage, obj);
  //        messagef(NONE, "wait until %s finishes its do method before proceeding\n", testflow_children[1]);
  //        testflow_children[1].as_a(csco_pci_env_u).wait_on_cur_test_phase();

  //        testflow_children[2].run_phase(stage, obj);
  //        return;
  //    };
  //};

  keep testflow.post_test_timer == 10 ns;
}; -- extend csco_shaggy_soc_env_u

extend csco_ge_env_u {
  do_post_test() @sys.any is only {
    messagef(NONE, "waiting 30 ns\n");
    wait delay(30 ns);
    messagef(NONE, "finished waiting 30 ns\n");
  };
};

extend global {
  start_test() is also {
    specman("set checks -run_time_match=\"...POST_TEST watchdog timer expired...\" WARNING");
  };
};

extend csco_pci_seq_driver_u {
  do_main_test() @sys.any is also {
    gen sequence;
    compute sequence.get_depth();
  };
};


'>
