For the pci sub env, we use a top down import approach.

<'

import csco_testflow/e/csco_testflow_top;
import csco_config/e/csco_config_top;

type csco_pci_env_inst_t : [INST_0];

unit csco_pci_env_u {
  CREATE_TESTFLOW;

  short_name() : string is also {
      result = appendf("PCI_%s", config.inst_name);
  };
};
DEFINE_CFG_STRUCT csco_pci_env csco_pci_env_u;

extend csco_pci_env_u {
  inst_name : csco_pci_env_inst_t;
    keep inst_name == value(config.inst_name);

  del : time;
    keep del >= 0 ns;
    keep del <= 10 ns;

  pass_random_time() @sys.any is {
    gen del;
    messagef(NONE, "waiting %d ns\n", from_specman_scale(del, ns));
    wait delay(del);
  };

  do_pre_reset() @sys.any is {
    pass_random_time();
  };

  do_reset() @sys.any is {
    //messagef(NONE, "DEBUG: do_reset() called\n");
    pass_random_time();
    //messagef(NONE, "DEBUG: do_reset() finished\n");
  };

  do_init_test() @sys.any is {
    pass_random_time();
  };

  do_pre_test() @sys.any is {
    pass_random_time();
  };

  do_main_test() @sys.any is {
    pass_random_time();
  };

  do_post_test() @sys.any is {
    pass_random_time();
  };

  do_post_test_check() @sys.any is {
    pass_random_time();
  };
}; -- extend csco_pci_env_u

extend csco_pci_env_config_s {
  inst_name : csco_pci_env_inst_t;
};

'>
