To compose the top shaggy soc env, we use a bottoms up import approach.

<'
import csco_clkgen/e/csco_clkgen_top;
import csco_testflow/e/csco_testflow_top;
import csco_config/e/csco_config_top;
import csco_ge_env;
import csco_pci_env_top;

extend csco_pci_env_inst_t : [INST_1]; 

extend sys {
  csco_shaggy_soc_env_u is instance;
};

unit csco_shaggy_soc_env_u { 
  clkgen : csco_clkgen_u is instance;
    keep clkgen.config.active_passive == ACTIVE;
    keep clkgen.config.period == 2000;
    keep clkgen.config.edge_mode == POSEDGE;
    keep clkgen.sig_clock.hdl_path() == "~/testbench.clock";

  CREATE_TESTFLOW;

  short_name() : string is also {
    result = "SHAGGY";
  };

  ge_env : csco_ge_env_u is instance;

  pci0 : INST_0 csco_pci_env_u is instance;

  pci1 : INST_1 csco_pci_env_u is instance;

  run() is first {
    messagef(NONE, "DEBUG: pre_reset objection counter = %d\n", get_objection_total(PRE_RESET_DONE));
    messagef(NONE, "DEBUG: reset objection counter = %d\n", get_objection_total(RESET_DONE));
    messagef(NONE, "DEBUG: init_test objection counter = %d\n", get_objection_total(INIT_TEST_DONE));
    messagef(NONE, "DEBUG: test objection counter = %d\n", get_objection_total(MAIN_TEST_DONE));
    messagef(NONE, "DEBUG: post_test objection counter = %d\n", get_objection_total(POST_TEST_DONE));
  };

  del : time;
    keep del >= 0 ns;
    keep del <= 10 ns;

  pass_random_time() @sys.any is {
    gen del;
    messagef(NONE, "waiting %d ns\n", from_specman_scale(del, ns));
    wait delay(del);
  };

  do_pre_reset() @sys.any is {
    pass_random_time();
  };

  do_reset() @sys.any is {
    pass_random_time();
  };

  do_init_test() @sys.any is {
    pass_random_time();
  };

  do_pre_test() @sys.any is {
    pass_random_time();
  };

  do_main_test() @sys.any is {
    pass_random_time();
  };

  do_post_test() @sys.any is {
    pass_random_time();
  };

  do_post_test_check() @sys.any is {
    pass_random_time();
  };
};
DEFINE_CFG_STRUCT csco_shaggy_soc_env csco_shaggy_soc_env_u;

ADD_CHILD_CFG (csco_shaggy_soc_env_u) ge_env (csco_shaggy_soc_env_config_s) ge_cfg (csco_ge_env_config_s);
ADD_CHILD_CFG (csco_shaggy_soc_env_u) pci0 (csco_shaggy_soc_env_config_s) pci0_cfg (INST_0 csco_pci_env_config_s);
ADD_CHILD_CFG (csco_shaggy_soc_env_u) pci1 (csco_shaggy_soc_env_config_s) pci1_cfg (INST_1 csco_pci_env_config_s);


'>
