// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
//
// File name    : csco_trans_types.e
//              :
// Project      : csco_trans
//              :
// Created On   : 11/08/2005
//              :
//              :
// Description  : This file contains some common type definitions and 
//                instantiates a package specific utility unit in sys.
//                
//              :
// Assumptions  : none
//              :
// Limitations  : none
//              :
// Known Errors : none
//              :
// Notes        :
//
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Copyright 2003 (c) Cisco Systems Inc.
//
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


<'
package csco_trans;

extend message_tag : [CSCO_TRANS];

// When determinant type used to extend transaction
// tracking structs to modify/add behavior.
type csco_trans_kind_t : [NONE];

// Whether a transaction is a generated stimulus (GEN) or a 
// monitored transaction (MON).
type csco_trans_origin_t : [MON, GEN, TMP];


unit csco_trans_env_u like any_env { };

extend sys {
  csco_trans_env : csco_trans_env_u is instance;
};

// port attribute to indicate whether bound set is a leaf or downstream children are expected -- any ports being FALSE make the bound set FALSE
add port attribute  csco_trans_not_leaf -type=bool -def=FALSE;

'>
