`timescale 1ns/1ns

//==============================================================================
//
//   Filename : testbench.v
//   Author   : Sean Smith
//   username : sesmith
//
//   General Description: Top Level Verilog Testbench file for Cisco Shaggy ASIC
//                        Unit Level testbench in Cisco Env.  This file is not
//                        re-usable.  This file will be replaced by the
//                        hdl PM_05_SOC TB for chip level testing of the csco_hwa
//                        block
//
//   History:
//   06/26/03  SWS    Initial Template testbench
//
//==============================================================================

module testbench;


// Counter to Track Denali Errors
//
integer denali_error_count;
integer den_status;

integer dram_0_id, dram_1_id, dram_2_id, dram_3_id, dram_id, dram_id_par, iram_id, iram_id_parity, iram_id_phys;

reg clock;

// Load The Specman Code and Include any necessary Wave Trace Files
//
// Waves control
//------------------------------------------------------------------------

initial
  begin
    `ifdef tpd  // tpd is defined
      $display("%t ns (%m) TPD is DEFINED!\n",$time);
    `else
      $display("%t ns (%m) TPD is NOT DEFINED!\n",$time);
    `endif
  end

initial
  begin
    $timeformat(-9,0," ns",12);
    denali_error_count = 0;
    $sn("--");  // Need to Call Specman After We Create Denali System/Logical Memories to use in Specman
  end

endmodule
