<'
import csco_verbosity/e/csco_verbosity_top;

type color_t : [BLUE, YELLOW, RED];

method_type dummy_method() @sys.any;


struct base_struct_s {
  parent_hex : uint;

  parent_dec : uint;
    csco_print_attr parent_dec ALL enable;
    csco_print_attr parent_dec ALL header=p_dec radix=DEC;

  time_field : time;
    keep time_field <= 10 ms;
    keep time_field > 0;

  !null_field : any_struct;
    csco_print_attr null_field ALL enable;
    csco_print_attr null_field ALL expand=ON;

  parent_list : list of uint(bits:32);
    keep for each in parent_list {
      soft it <= 64;
    };
    csco_print_attr parent_list SHORT enable;
    csco_print_attr parent_list ALL header=p_list;
};

struct inherited_struct_s like base_struct_s {
  str_field : string;

  color : color_t;
    csco_print_attr color ALL enable;

  long_bin : int(bits:80);
    keep long_bin == -5;
    csco_print_attr long_bin ALL enable;
    csco_print_attr long_bin ALL radix=BIN;

  long_hex : int(bits:80);
    keep long_hex == -5;
    csco_print_attr long_hex ALL enable;
    csco_print_attr long_hex ALL radix=HEX;

  long_dec : int(bits:32);
    keep long_dec == 5;
    csco_print_attr long_dec ALL enable;
    csco_print_attr long_dec ALL radix=%08d;

  depth : uint;
    keep soft depth == 0;
    // The attributes below allows short printing but disables long printing.
    csco_print_attr depth SHORT enable;
    csco_print_attr depth LONG disable;
    csco_print_attr depth SHORT precede=color;

  csco_print_get_tree_depth(clist_path : string) : int is { result = depth; };

  !downstream : list of inherited_struct_s;
    csco_print_attr downstream ALL enable;

  post_generate() is also {
    str_field = "CHILD_STRING_FIELD VALUE";
  };

  when RED inherited_struct_s {
    red_field : uint;
      csco_print_attr red_field ALL enable;
  };

  when BLUE inherited_struct_s {
    blue_field : uint;
  };

  when YELLOW inherited_struct_s {
    yellow_field : uint;
      csco_print_attr yellow_field ALL enable;
  };
};

extend sys {
  csco_print_attr csco_verbosity_utils ALL disable;

  extern_port : out simple_port of uint is instance;
    keep bind(extern_port, external);
    csco_print_attr extern_port ALL enable;

  sys_str_field : string;
    keep soft sys_str_field == "Hello World";

  mp_out : out method_port of dummy_method is instance;
    csco_print_attr mp_out LONG enable;

  base_struct : base_struct_s;
    csco_print_attr base_struct ALL enable;
    csco_print_attr base_struct ALL header=base_s expand=ON;

  unexpanded_struct : base_struct_s;
    csco_print_attr unexpanded_struct ALL header=unexp_s;

  mp_in : in method_port of dummy_method is instance;
  mp_in() @sys.any is empty;
    csco_print_attr mp_in ALL enable;

  inherited_struct_list : list of inherited_struct_s;
    keep inherited_struct_list.size() > 5;
    keep soft inherited_struct_list.size() < 20;
    csco_print_attr inherited_struct_list SHORT enable;
    csco_print_attr inherited_struct_list SHORT expand=ON;
    csco_print_attr inherited_struct_list LONG header=inh_s;

  base_struct_list : list of base_struct_s;
    keep soft base_struct_list.size() < 10;
    csco_print_attr base_struct_list SHORT enable;
    csco_print_attr base_struct_list SHORT precede=base_struct expand=ON;
    csco_print_attr base_struct_list LONG disable;

  expanded_struct_list : list of base_struct_s;
    keep expanded_struct_list.size() <= 5;
    csco_print_attr expanded_struct_list LONG header=exp_slist expand=ON;

  connect_ports() is also {
    do_bind(mp_out, mp_in);
  };

  run() is also {
    var tmp_downstream : inherited_struct_s;

    gen base_struct;
    gen tmp_downstream keeping { .depth == 1; };
    inherited_struct_list[1].downstream.add(tmp_downstream);
    gen tmp_downstream keeping { .depth == 1; };
    inherited_struct_list[1].downstream.add(tmp_downstream);
    gen tmp_downstream keeping { .depth == 2; };
    inherited_struct_list[1].downstream[0].downstream.add(tmp_downstream);
    gen tmp_downstream keeping { .depth == 2; };
    inherited_struct_list[1].downstream[1].downstream.add(tmp_downstream);

    if inherited_struct_list.size() > 5 {
      inherited_struct_list[5] = NULL;
    };
  };

  run() is also {
    message(NONE, "printing sys short") {
      csco_print(SHORT);
    };

    outf("\n");
    message(NONE, "printing sys long") {
      csco_print(LONG);
    };

    outf("\n");
    message(NONE, "printing sys.inherited_struct_list[0] long") {
      inherited_struct_list[0].csco_print(LONG);
    };

    outf("\n");
    message(NONE, "printing sys.inherited_struct_list[1] tree short") {
      inherited_struct_list[1].csco_print_sub_tree(SHORT, "downstream");
    };

    outf("\n");
    message(NONE, "printing sys.inherited_struct_list[1] tree long") {
      inherited_struct_list[1].csco_print_sub_tree(LONG, "downstream");
    };
  };

  csco_print_attr csco_verbosity ALL disable;
};

extend csco_verbosity_u {
  keep verbosity_file == "non_existent_file";
};


extend global {
  setup_test() is also {
    specman("set notify -severity=IGNORE WARN_TIME_UNITS_TRUNCATED");
  };
};

'>
